﻿// --------------------------------------------------------------------------------------------
// Create the data page: top-level tabs, vertical tabs in groups, iframe etc
function formatPage() {

    function getCurrentDataset(returnType) {
        currentHash = window.top.location.hash;
        currentDataset = currentHash.split("Home/Home.htm#&dataset=")[1];
        if (typeof currentDataset != "undefined") {
            currentDataset = currentDataset.split("&")[0];
            currentDatasetText = currentDataset.split("+").join(" ");
            currentDatasetPath = currentDataset.split("+").join("_");
            currentDatasetCode = currentDataset;
            if (returnType == "text") {
                return currentDatasetText;
            }
            if (returnType == "path") {
                return currentDatasetPath;
            }
            if (returnType == "code") {
                return currentDatasetCode;
            } else {
                return "";
            }
        } else {
            return "";
        }
    }

    function getCurrentTab() {
        currentHash = window.top.location.hash;
        currentTab = currentHash.split("&tab=")[1];
        if (typeof currentTab != "undefined") {
            currentTab = currentTab.split("&")[0];
            currentTab = currentTab.split("+").join(" ");
            return currentTab;
        } else {
            return "";
        }
    }
	
    function getTabRef() {
        currentHash = window.top.location.hash;
        tabRef = currentHash.split("&tabref=")[1];
        if (typeof tabRef != "undefined") {
            tabRef = tabRef.split("&")[0];
            return tabRef;
        } else {
            return "";
        }
    }
	
    function getDetailRef() {
        currentHash = window.top.location.hash;
        detailRef = currentHash.split("&detailref=")[1];
        if (typeof detailRef != "undefined") {
            detailRef = detailRef.split("&")[0];
            return detailRef;
        } else {
            return "";
        }
    }
	
    function formatDataPage() {
		// Insert a paragraph for tracking file-not-found errors
		$("body").prepend("<p id='tracker'></p>");
        // Get a list of all datasets from the embedded TOC
        var allFiles = $('.MCTocProxy_0 td a[href]');
        var datasetList = "";
        for (var i = 0; i < allFiles.length; i++) {
			// Update the tracking paragraph
			$("p#tracker").html("Issue with TOC item " + (i + 1) 
				+ ": <b>" + $(allFiles[i]).text() 
				+ "</b><br /><i>" + $(allFiles[i]).attr("href") + "</i>");
			$("p#tracker").css("color","red");
			// Highlight current TOC item
			$("a.GenTOCText1:eq(" + (i - 1) + ")").css("color","#0C349C");
			$("a.GenTOCText1:eq(" + i + ")").css("color","red");
			// Create tabs for each dataset and additional dataset
            var initialFile = $(allFiles[i]).attr("href").split("../")[1];
            initialFile = initialFile.split("/")[0];
            if (datasetList.indexOf(initialFile) < 0) {
                datasetList = datasetList + "|" + initialFile;
            }
        }
		// On complete, remove the tracking paragraph and hide the MadCap proxy
		$("p#tracker").remove();
        $('div[class*="MCTocProxy_"]').css("display", "none");
		
		// Create array from the list of datasets
        datasetList = datasetList.split("|");
        datasetList = datasetList.slice(1, datasetList.length);
		// Create a tab for each dataset
        for (var i = 0; i < datasetList.length; i++) {
            var datasetTabName = datasetList[i].split('__').join('');
            var newDatasetTabName = datasetTabName.split('_').join(' ');
            newDatasetTabCodeName = datasetTabName.split(' ').join('+');
            newDatasetTabRealName = newDatasetTabCodeName;
			// Process dataset tab keywords (dataset codes in square brackets)
			if (newDatasetTabName.indexOf("]") != -1){
				newDatasetTabName = newDatasetTabName.split("]")[1];
				newDatasetTabName = $.trim(newDatasetTabName);
				newDatasetTabCodeName = newDatasetTabCodeName.split("]")[0];
				newDatasetTabCodeName = newDatasetTabCodeName.replace("[","");
				// Special case for the 'All' tab (use question mark instead of country name)
				//if (newDatasetTabCodeName.toLowerCase() == "all"){
				//	newDatasetTabName = "?";
				//}
			}
            var newDatasetTab = "<div class='datasetTab'" + " urltext='" + newDatasetTabCodeName + "' tabname='__" + newDatasetTabRealName + "' id='datasetTab" + i + "'>" + newDatasetTabName + "</div>";
            $("#datasetTabs").append(newDatasetTab);
        }
		// Add additional styles to the first tab
		$("#datasetTabs .datasetTab").first().addClass("countryTab");
		// Rearrange the tabs to make sure the bottom row is always longest (works for a max of 2 rows only...)
		var $DatasetTabsGroup = $("#datasetTabs");
		var $DatasetTabs = $("#datasetTabs .datasetTab");
		$("body").css({	visibility: "hidden", display: "block" }); // make the tabs measureable
			var totalWidth = $DatasetTabsGroup.outerWidth(); // measure the space for all tabs
			var widthOfAllTabs = 0; // measure the actual space required by all tabs
			$.each($DatasetTabs, function() {
			  widthOfAllTabs += $(this).outerWidth();
			});
			
			if (widthOfAllTabs >= totalWidth) // find out if a second row is required
			{
				// Create divs for the rows
				var $topRowTabs = $("<div/>", { "class": "datasetTabsRow1" });
				var $bottomRowTabs = $("<div/>", { "class": "datasetTabsRow2" });
				$DatasetTabsGroup.append($topRowTabs);
				$DatasetTabsGroup.append($bottomRowTabs);
				// Calculate number of tabs to go in each row
				var totalTabs = $DatasetTabs.length; // number of tabs in total
				var totalTopRowTabs = Math.floor(totalTabs/2); // number of tabs for the top row
				var totalBottomRowTabs = Math.ceil(totalTabs/2); // number of tabs for the bottom row
				if (totalTopRowTabs == totalBottomRowTabs) // Adjust calculation if both rows have same number of tabs
				{
					totalTopRowTabs--;
					totalBottomRowTabs++;
				}
				// Move tabs into the appropriate rows
				for (i=0; i < totalTopRowTabs; i++)
				{
					$("#datasetTabs .datasetTab").first().appendTo($topRowTabs);
				}
				for (i=0; i < totalBottomRowTabs; i++)
				{
					$("#datasetTabs .datasetTab").first().appendTo($bottomRowTabs);
				}
				// Move body elements to create space for the additional row
				$("#mainContainer").addClass("twoRows");
			}
		$("body").css({	visibility: "visible", display: "none" }); // return the tabs to their original states
			
		// Create an object based on the dataset requested in the URL (if any)
		var requestedDataset = getCurrentDataset("code");
		var requestedDatasetTab = $('.datasetTab[urltext="' + requestedDataset + '"]').first();
		var requestedDatasetPath = requestedDatasetTab.attr("tabname");
		// If that fails, try again with a variety of casings
		if (requestedDatasetTab.length < 1){
			requestedDataset = requestedDataset.toLowerCase();
			requestedDatasetTab = $('.datasetTab[urltext="' + requestedDataset + '"]').first();
		}
		if (requestedDatasetTab.length < 1){
			requestedDataset = requestedDataset.toUpperCase();
			requestedDatasetTab = $('.datasetTab[urltext="' + requestedDataset + '"]').first();
		}		
		// Highlight the appropriate dataset tab (if one is requested in the URL)
		if (requestedDatasetTab.length > 0){
			requestedDatasetTab.addClass("active");
		}
        // Go to first dataset tab (if none is stipulated in the URL)
		else {
			var newHash = "Home/Home.htm#&dataset=" + $(".datasetTab").first().attr("urltext");
			window.parent.location.hash = newHash;
			window.top.location.hash = newHash;
			$(".datasetTab").first().addClass("active");
		}
		
    }
	
    function createContent() {

		// Get a list of all subfolders for the active dataset
		var activeDatasetPath = ($(".datasetTab.active").attr("tabname"));
		// Error to catch spaces within a folder name
		if (activeDatasetPath.indexOf("+") != -1){
			var dodgyFolder = activeDatasetPath.split("+").join(" ");
			var correctFolder = activeDatasetPath.split("+").join("_");
			var errorText = '<h4 style="color:red">Internal error</h4>'
							+'<br><br>The folder "<b>' + dodgyFolder
							+ '</b>" contains one or more spaces.'
							+ '<br><br>Replace the spaces with underscores and rebuild the Flare project to continue.'
							+ '<br><br>The new folder name should be: <b>' + correctFolder + '</b>';
			var error = "<div id='errorMessage' style='color:red'>" + errorText + "</div>"
			$(error).insertBefore($("#innerContainer"));
			$(".datasetTab.active").css("background","lightyellow");
			$("#mainContainer").css("background","lightyellow");
			$("#innerContainer").css("display","none");
		}
		else {	
		var datasetSubfolderFilter = $('.MCTocProxy_0 td a[href*="' + activeDatasetPath + '/"]');
        var datasetSubfolders = "";
        for (var i = 0; i < datasetSubfolderFilter.length; i++) {
            var subfolder = $(datasetSubfolderFilter[i]).attr("href").split("/")[2];
            // Add the subfolder to an array only if it is not already included
            if (datasetSubfolders.indexOf(subfolder) < 0) {
                datasetSubfolders = datasetSubfolders + subfolder + ",";
            }
        }
        // Trim last comma from array
        datasetSubfolders = datasetSubfolders.substring(0, datasetSubfolders.length - 1);
        datasetSubfolders = datasetSubfolders.split(",");

        // Add a tab group for each subfolder
        for (var j = 0; j < datasetSubfolders.length; j++) {
            var newBase = datasetSubfolders[j].split("__").join("");
            additionalClass = "";
            // Set up an additional class to mark out appropriate groups, such as DataPlus groups
            if (newBase.indexOf("[DataPlus]") != -1) {
                newBase = newBase.split("[DataPlus]").join("");
                additionalClass = additionalClass + " dataPlusGroup";
            }
            var newId = newBase.split("_").join("");
			newId = newBase.split(" ").join("");
            var newText = newBase.split("_").join(" ");
            var newTabHeader = "<div class='tabHeader' id='" + newId + "Header'>" + "<div class='tabHeaderText'>" + newText + "</div>" + "<div class='tabHeaderArrow'></div>" + "</div>"
            var newTabGroup = "<div class='tabGroup" + additionalClass + "' id='" + newId + "Group'></div>";
            $("#tabs").append("<div id='" + newId + "Container' class='tabGroupContainer'></div>");
            $("#" + newId + "Container").append(newTabHeader);
            $("#" + newId + "Container").append(newTabGroup);
			
            // Add a tab for each file and place them beneath their subfolders
            var datasetTabs = $(".MCTocProxy_0 td a[href*='" + activeDatasetPath + "/" + datasetSubfolders[j] + "/" + "']");
            for (var i = 0; i < datasetTabs.length; i++) {
                var tabText = $(datasetTabs[i]).text().split("/").join("/ ");
                var tabLink = $(datasetTabs[i]).attr("href");
				var tabFolder = tabLink.split("/");
				tabFolder = tabFolder[tabFolder.length-2];
				// Only add this tab if the file is not in a third-level subfolder
				if (tabFolder.indexOf("__") != -1){
					// If this is a DataPlus tab, tabName is the htm filename (which should be the DataPlus set code)
					if(datasetSubfolders[j].indexOf("[DataPlus]") != -1){
						var tabName = tabLink.split("/");
						tabName = tabName[tabName.length - 1].replace(".htm","");
						tabName = tabName.split(/\s/g).join("+");
						tabName = tabName.toLowerCase();
					}
					// Otherwise, tabName is the same as the tab's text, but with plus signs instead of spaces
					else{
		                var tabName = tabText.split(/\s/g).join("+");
		                tabName = tabName.split("/").join("");
						tabName = tabName.toLowerCase();
					}
	                var newTab = "<div><a " + "class='contentTab' " + "href='" + tabLink + "' " + "target='contentiframe' " + "tabname='" + tabName + "'>" + tabText + "</a></div>";
	                $("#" + newId + "Group").append(newTab);
	            }
			}
            $("#" + newId + "Container").append('<div class="tabGroupFade"></div>');
        }

        // Add the 'About DataPlus' button and link, if a DataPlus tab group exists
        if ($(".dataPlusGroup").length > 0) {
            var AboutDataPlusPara = "<div><a " + "class='contentTab aboutDataPlustab' " + "href='AboutDataplus.htm' " + "target='contentiframe' " + "tabname='about+dataplus' " + ">" + "About DataPlus" + "</a></div>";
            $(AboutDataPlusPara).prependTo($(".dataPlusGroup").first());
        }
        // Style the last tab
        $(".contentTab").last().css("borderBottomColor", "#B3BEC4");
        // Hide all tabGroups, except the first
        $(".tabGroup").css("display", "none");
        $(".tabGroup").first().css("display", "block");
        $(".tabContainer").first().addClass("active");
        $(".tabGroupContainer.active .tabGroupFade").css("display", "block");
        $(".tabGroup").first().addClass("active");
        $(".tabHeader").first().addClass("active");
    }
	}
	
    // Run initial processes using the above functions
	if (window.location != window.top.location){
	    formatDataPage();
	    createContent();
		if($('#errorMessage').length < 1){
		    // Start tracking the size of the iframe's content
		    adjustFrameHeight();
		    // Start tracking the size of the tabGroups' content
		    $(".tabGroup").bind("scroll", scrollCheck);
			processTabGroupHeight();
		}
	}
	
    // Click a horizontal tab
    $(".datasetTab").click(function () {
        if (!$(this).hasClass("active")) {
            // Style dataset tabs
            $(".datasetTab").removeClass("active");
            var urltext = $(this).attr("urltext");
            $(this).addClass("active");
            // Change content
            var newHash = window.top.location.hash.split("Home/Home.htm#&dataset")[0];
            newHash = newHash + "Home/Home.htm#&dataset=" + urltext;
            window.top.location.hash = newHash;
            window.parent.location.hash = newHash;
            window.location.reload();
        }
    });

    // Click a tab header
    $(".tabHeader").click(function () {
        // Click an inactive header
        if (!$(this).hasClass("active")) {
            var headerName = $(this).attr("id");
            groupName = headerName.replace("Header", "Group");
            groupContainer = headerName.replace("Header", "Container");
            $(".tabHeader").removeClass("active");
            $(".tabGroupContainer.active .tabGroupFade").css("display", "none");
            $(".tabGroup").slideUp();
            $("#" + groupName).slideDown(400, function () {
                $(".tabGroup").removeClass("active");
                $(".tabGroup").removeClass("scrolled");
                $(".contentTab").removeClass("active");
                $(".tabGroupContainer.active .tabGroupFade").css("display", "none");
                $(".tabGroupContainer").removeClass("active");
                $("#" + groupName).addClass("active");
                $("#" + groupContainer).addClass("active");
                $(".tabGroupContainer.active .tabGroupFade").css("display", "block");
                $("#" + groupName + " .contentTab").first().addClass("active");
                $("#content iframe").attr("src", $("#" + groupName + " .contentTab").first().attr("href"));
                // Update the URL
                var tabName = $("#" + groupName + " .contentTab").first().attr("tabname");
				tabName = toTitleCase(tabName);
                var newHash = window.top.location.hash.split("&tab=")[0];
				newHash = newHash + "&tab=" + tabName;
                window.parent.location.hash = newHash;
                window.top.location.hash = newHash;
                $("#" + headerName).addClass("active");
                //set tabGroup's max height
                processTabGroupHeight();
                // Postion tabGroup's fader
                var groupHeight = $("#" + groupName).height();
                $("#" + groupName + " .tabGroupFade").position($("#" + headerName).position());
                reRenderTabs();
            });
        }
        // Click an active header
        else {

            var allTabHeaders = $(".tabHeader");
            for (var i = 0; i < allTabHeaders.length; i++) {
                if ($(".tabHeader:eq(" + i + ")").hasClass("active")) {
                    var indexOfThisTabHeader = i;
                }
            }
            if (indexOfThisTabHeader == 0) {
                $(".contentTab:eq(0)").trigger("click");
            } else {
                $(".contentTab:eq(0)").trigger("click");
            }
        }
        $(".tabGroup.active").scrollTop(0);
    });

    // Click a tab
    $(".contentTab").click(function () {
        // Style tabs when one is selected
        $(".contentTab").removeClass("active");
        $(this).addClass("active");
        // Update the URL
        var tabName = $(this).attr("tabname");
		// If this is a DataPlus tab, update the URL in caps
		if ($(this).parent().parent().hasClass("dataPlusGroup") && !$(this).hasClass("aboutDataPlustab")){
			tabName = tabName.toUpperCase();
		}
		// Otherwise, update the URL in title case
		else {
			tabName = toTitleCase(tabName);
		}
        var newHash = window.top.location.hash.split("&tab=")[0];
		newHash = newHash + "&tab=" + tabName;
        window.parent.location.hash = newHash;
        window.top.location.hash = newHash;
        // Scroll selected tab into view if it was behind the fadeout
        var relativeTabTop = $(this).offset().top - $(".tabGroup.active").offset().top;
        if (relativeTabTop > ($(this).height() * 2) && relativeTabTop > ($(".tabGroup.active").height() / 1.3)) {
            $(".tabGroup.active").scrollTop($(".tabGroup.active").scrollTop() + ($(this).height() + 30));
        }
        // Scroll selected tab into view if it was behind the header
        if (relativeTabTop < 0) {
            $(".tabGroup.active").scrollTop($(".tabGroup.active").scrollTop() - ($(this).height() * 1.5));
        }
        reRenderTabs();
    });

    // Keep track of the amount of content in the iframe, and create/adjust scrollbar as necessary
    function adjustFrameHeight() {
        $(function ($) {
            var lastHeight = 0,
                curHeight = 0,
                $frame = $('#content iframe');
            setInterval(function () {
                curHeight = $frame.contents().find('body').height();
                if (curHeight != lastHeight) {
                    $frame.css('height', (lastHeight = curHeight) + 20 + 'px');
                }
            }, 50);
        });
    }
	// Check which tab to activate and highlight
	
	if (getTabRef() != ""){
		var referencedTab = $(".contentTab[href*='" + getTabRef() + "']");
		referencedTabName = $(referencedTab).attr("tabname");
		if (!$(referencedTab).parent().parent().hasClass("dataPlusGroup")){
			referencedTabName = toTitleCase(referencedTabName);
		}
		else{
			referencedTabName = referencedTabName.toUpperCase();
		}
		var tabToHighlight = referencedTabName;
		var newHash = window.top.location.hash.split("&tabref")[0];
		newHash = newHash + "&tab=" + referencedTabName + "&detailref=" + getDetailRef();
		window.top.location.hash = newHash;
	}
	else{
		var tabToHighlight = getCurrentTab().replace("#", "");
		tabToHighlight = tabToHighlight.split(' ').join('+');
	}
	var requiredTab = $("[tabname='" + tabToHighlight + "']");
	// If that fails, try again with a variety of casings
	if (requiredTab.length < 1){
		tabToHighlight = tabToHighlight.toLowerCase();
		requiredTab = $("[tabname='" + tabToHighlight + "']");
	}
	if (requiredTab.length < 1){
		tabToHighlight = tabToHighlight.toUpperCase();
		requiredTab = $("[tabname='" + tabToHighlight + "']");
	}
	// Select the required contentTab and its tabHeader (if a tab is stipulated in the URL)
	if (requiredTab.length > 0){
		var requiredTabHeader = $(requiredTab).parent().parent();
		// Close all tabGroups and remove active classes
		$(".tabGroup").css("display", "none");
		$(".tabGroup").removeClass("active");
		$(".tabHeader").removeClass("active");
		$(".tabContainer").removeClass("active");
		// Open required tabGroup and add active classes
		$(requiredTabHeader).addClass("active");
		$(requiredTabHeader).parent().addClass("active");
		$(requiredTabHeader).css("display", "block");
		$(requiredTabHeader).parent().children(".tabHeader").addClass("active");
		$(requiredTab).addClass("active");
		$("#content iframe").attr("src", $(requiredTab).attr("href"));
	}
	// Go to first tab (if none is stipulated in the URL)
	else {
		// Access the first tab by default
		var initialHref = $(".contentTab").first().attr("href");
		$("#content iframe").attr("src", initialHref);
		$(".contentTab").first().addClass("active");
		$(".tabGroupContainer").first().addClass("active");
		$(".tabGroupContainer.active .tabGroupFade").css("display", "block");
		// Update the URL
		if (getCurrentDataset("path") == "All" || getCurrentDataset("path") == "ALL" || getCurrentDataset("path") == "all"){
			currentDataset = "All";
		}
		else {
			currentDataset = getCurrentDataset("path").toUpperCase();
		}
		var tabName = $(".contentTab").first().attr("tabname");
		tabName = toTitleCase(tabName);
		var newHash = "Home/Home.htm#&dataset="	+ currentDataset + "&tab=" + tabName;
		window.parent.location.hash = newHash;
		window.top.location.hash = newHash;
	}
 
    // Check whether fadeout is required
    processTabGroupHeight();
    // Scroll selected tab into view if it was behind the fadeout
    var relativeTabTop = $(".contentTab.active").offset().top - $(".tabGroup.active").offset().top;
    if (relativeTabTop > ($(".contentTab.active").height() * 2) && relativeTabTop > ($(".tabGroup.active").height() / 1.3)) {
        $(".tabGroup.active").first().scrollTop($(".contentTab.active").offset().top);
    }
	
	// Hide tabHeader if there is only one
	if ($(".tabHeader").length < 2) {
		$(".tabHeader").css("display", "none");
		$(".contentTab").first().css("borderTopWidth", "1px");
		$(".contentTab").css("width", "9.9em");
		$(".tabGroup").css("maxHeight", "1000em");
	}

    // Keep track of the amount of tabs in a group, and create/adjust scrollbar as necessary
    function processTabGroupHeight() {
		setInterval(function () {
			if (!$(".tabGroup.active").hasClass("scrolled")){
		        // Make sure tab groups never get too tall; add a scrollbar if required
				if ($("#mainContainer").hasClass("twoRows")) { var groupMaxHeight = 438; } // the height of the #tabs div; hardcoded because FF was having issues
				else { var groupMaxHeight = 466; }
		        var numberOfTabHeaders = $(".tabHeader").length;
				var tabHeaderHeight = 28; // the height of a .tabHeader div; hardcoded because FF was having issues
		        var totalTabHeaderHeight = numberOfTabHeaders * tabHeaderHeight;
				
				// Offsets to deal with different browser's rendering to a pixel-perfect level
				if (navigator.userAgent.match(/firefox/i)){ 
					var offset = 2;
				}
				else if (navigator.userAgent.match(/msie/i)){ 
					var offset = 0;
				}
				else {
					var offset = 1;
				}
				
		        $(".tabGroup.active").css("maxHeight", groupMaxHeight - totalTabHeaderHeight - offset);
				
		        // If a scrollbar is not present, hide the fadeout
		        var groupHeight = $(".tabGroup.active").height();
		        var groupScrollHeight = $(".tabGroup.active")[0].scrollHeight;
		        if (groupScrollHeight <= groupHeight) {
		            $(".tabGroupContainer.active .tabGroupFade").css("display", "none");
		        }
				// If the required tab might be behind the fadeout, scroll it into view
				$(".tabGroup.active").scrollTop($(".contentTab.active").offset().top 
					- $(".tabGroup.active").offset().top - 40);
				// Trigger this function on page load
				$(".tabGroup.active").trigger("scroll");
				$(".tabGroup.active").addClass("scrolled");
			}
		}, 50);
    }

    // Keep track of the position of the tabs' scrollbar, and add/remove fadeout as necessary
    function scrollCheck(e) {
        var elem = $(e.currentTarget);
        if (elem[0].scrollHeight - elem.scrollTop() == elem.outerHeight()) {
            $(".tabGroupContainer.active .tabGroupFade").css("display", "none");
        } else {
            $(".tabGroupContainer.active .tabGroupFade").css("display", "block");
        }
        processTabGroupHeight();
    }
	
	function toTitleCase(text){
		text = text.replace(/\w*/g, function(txt){return txt.charAt(0).toUpperCase() + txt.substr(1).toLowerCase();});
		text = text.split("Qas").join("QAS");
		text = text.split("Dataplus").join("DataPlus");
		return text;
	}

    function reRenderTabs() {
        $("#tabs").fadeOut(0).fadeIn(0);
    }
	
}

// --------------------------------------------------------------------------------------------
// Automtically create tabs or dropdowns from MiniTOC proxies

function automaticFormatting() {

	// Remove the first header from any page within the data content iframe, if it is the first element on the page
	if (window.parent.$("html").first().hasClass("dataPage")
		|| window.parent.parent.$("html").first().hasClass("dataPage")){
			$("body>:header:nth-child(2)").remove();
	}
	
	
	// If the page includes automatic tabs or dropdowns, create an iframe to display their content
    if ($(".MCMiniTocBox_automatic-tabs_0").length > 0 || $(".MCMiniTocBox_automatic-dropdowns_0").length > 0) {
        var iframe = "<iframe class='subIframe' name='subIframe' onload='' src='' frameborder='0' scrolling='no'><h1>iFrames Not Supported</h1><p>Your browser does not support iFrames, which are required to view this site.</p><p>Please <a href='_http://www.browser-update.org/update.html'>update your browser</a> to continue.</p></iframe>"
        $(".MiniTOC1_0 a").attr("target", "subIframe");

		// Insert tab content beneath the tabs
        if ($(".MCMiniTocBox_automatic-tabs_0").length > 0) {
            $(iframe).insertAfter($(".MCMiniTocBox_automatic-tabs_0"));
			if (navigator.userAgent.match(/chrome/i)) {
				$(".MiniTOC1_0").css("marginBottom", "0");
			}
			// Hide tabs and just include content if there's only one tab
			if ($(".MCMiniTocBox_automatic-tabs_0 .MiniTOC1_0").length == 1){
				$(".MCMiniTocBox_automatic-tabs_0").css("display","none");
				$(".subIframe").css("borderWidth","0");
				$(".subIframe").css("margin","-8px");
			}
        }

		// Insert dropdown content within the first dropdown
        if ($(".MCMiniTocBox_automatic-dropdowns_0").length > 0) {
            $(iframe).appendTo($(".MiniTOC1_0").first());
            $(".subIframe").css("display", "none");
            $(".subIframe").css("border", "0");
            $(".subIframe").css("marginTop", "0");
			// Make the dropdown's background appear transparent
			$(".subIframe").css("background", "#F5FAFF");
        }
    }

	// Keep track of the iframe's height and adjust scrollbar to match
    $(".subIframe").load(function () {
        jQuery(function ($) {
            var lastHeight = 0,
                curHeight = 0,
                $frame = $(".subIframe");
            setInterval(function () {
                curHeight = $frame.contents().find("body").height();
                if (curHeight != lastHeight) {
                    $frame.css("height", (lastHeight = curHeight) + 15 + 'px');
                }
            }, 50);
        });
		// Check how the tabs are displaying; if there's more than one row, make sure the last tab is the widest
		if (!$(".MiniTOC1_0").last().hasClass("calculated")){
			var allOffsets = "";
			for (var i = 0; i < $(".MiniTOC1_0").length; i++) {
				var rightHandSide = "" + $(".MiniTOC1_0:eq(" + i + ")").offset().top + "";
				if (allOffsets.indexOf(rightHandSide) == -1){
					allOffsets = allOffsets + "\n" + rightHandSide + "";
				}
			}
			var numberOfRows = allOffsets.split("\n").length-1;
			if (numberOfRows > 1)
			{
				var requiredWidth = $(".MCMiniTocBox_automatic-tabs_0").last().outerWidth() 
					- $(".MiniTOC1_0").last().offset().left;
				$(".MiniTOC1_0").last().css("width",requiredWidth);
			}
			$(".MiniTOC1_0").last().addClass("calculated");
		}		
    });

	// Click a tab
    $(".MCMiniTocBox_automatic-tabs_0 .MiniTOC1_0").click(function () {
        $(".subIframe").attr("src", $(this).children(":first").attr("href"));
        $(".MCMiniTocBox_automatic-tabs_0 .MiniTOC1_0").removeClass("active");
        $(this).addClass("active");
		// Update the URL hash
		updateUrlHash($(this));
    });

	// Click a dropdown
    $(".MCMiniTocBox_automatic-dropdowns_0 .MiniTOC1_0").click(function () {
        if ($(this).hasClass("active")) {
            $(".subIframe").css("display", "none");
            $(this).removeClass("active");
        } 
		else {
			$(".subIframe").attr("src", $(this).children(":first").attr("href"));
			$(".MiniTOC1_0").removeClass("active");
			$(this).addClass("active");
			$(".subIframe").appendTo($(this));
			$(".subIframe").css("display", "block");
			// Update the URL hash
			updateUrlHash($(this));
        }
    });
	
	function updateUrlHash(element){
		var innerTab = element.children("a.MiniTOC1").text().split(" ").join("+");
		var newHash = window.top.location.hash.split("&detail")[0];
		newHash = newHash + "&detail=" + innerTab;
		window.top.location.hash = newHash;
		window.location.hash = newHash;
	}

	// Open requested detail tab if 'detailref' is in the URL
	if (window.top.location.hash.indexOf("&detailref=") != -1){
		var detailref = window.top.location.hash.split("&detailref=")[1].split("&")[0];
			if(detailref != "" && typeof detailref != "undefined"){
				var referencedDetailTab = $("a.MiniTOC1[href*='" + detailref + "']");
				referencedDetailTabText = $(referencedDetailTab).text().split(" ").join("+");
				$(referencedDetailTab).first().trigger("click");
			}
			else{
				$("a.MiniTOC1").first().trigger("click");
			}
	}
    // Otherwise, open first tab/dropdown on page load
	else {
		$("a.MiniTOC1").first().trigger("click");
	}
	
	// Hack for Chrome's custom scrollbars
	if (navigator.userAgent.match(/chrome/i)){ 
		$(".tabGroup").css("left","0");
		$(".tabGroup").css("margin-right","0");
	}
		
}