// Create tabbed sections based on HTML elements as heading tabs
function automaticTabs()
{
	
	if($(".automaticTabs").length > 0){
	
		// get the element that will become headers
		if ($(".automaticTabs").first().attr("tabHeaders")){
			elementToUse = $(".automaticTabs").first().attr("tabHeaders");
		}
		else
		{
			// default to h4 
			elementToUse = "h4";
		}
		
		// Create tab headers and section names
		$(".automaticTabs " + elementToUse).addClass("tabHeader");
		for (var i = 0; i < $(".automaticTabs " + elementToUse).length; i++){
			tabSource = $(".automaticTabs " + elementToUse + ":eq(" + i + ")").text();
			// in code. only keep the part before the first pipe (|) character, to allow custom hashes
			tabName = tabSource.split("|")[0];
			// in text. only keep the part after the first pipe (|) character, to remove the custom hash
			tabText = tabSource.split("|");
			if(tabText.length > 1){	tabText.shift(); }
			tabText = $.trim(tabText);
			tabText = tabText.replace("     ","&newline&");
			
			tabName = $.trim(tabName).toLowerCase().split(" ").join("+").split(/\u00A0/).join("+");
			$(".automaticTabs " + elementToUse + ":eq(" + i + ")").attr("tab",tabName);
			$(".automaticTabs " + elementToUse + ":eq(" + i + ")").text(tabText);
			$(".automaticTabs " + elementToUse + ":eq(" + i + ")").html(
				$(".automaticTabs " + elementToUse + ":eq(" + i + ")").text().replace(
					"&newline&","<br /><span style='font-weight:normal'>"
				) + "</span>"
			);
			$(".automaticTabs " + elementToUse + ":eq(" + i + ")").nextUntil(".tabHeader").wrapAll("<div class='tabContent' tab='" + tabName + "' />");
		}		
		
		// wrap contents in a div
		$(".tabContent").wrapAll("<div class='allTabContents' />");
		$(".tabHeader").prependTo($(".automaticTabs").first());
	
		$(document).on('click', '.tabHeader:not(".active")', function() {
			// remember the tab that was clicked
			tabName = $(this).attr("tab");
			$(".tabContent").css("minHeight","0");
			// highlight only the tab that was clicked
			$(".tabHeader").removeClass("active");
			$(this).addClass("active");
			$(".tabHeader").removeClass("activeLastRow");
			$(".tabHeader[row='" + row + "'].active").addClass("activeLastRow");
			if($(".tabHeader.small.active").get(0) == $(".tabHeader.small").last().get(0)){
				$(".tabHeader.small.active").addClass("activeLastRow");
			}
			// rearrange the tab content (put the active contents at the top)
			$(".tabContent[tab='" + tabName + "']").prependTo(".allTabContents");
			// animate open and closing of tab content
			$(".tabContent.active").slideUp(300);
			$(".tabContent[tab='" + tabName + "']").slideDown(function(){
				if($(".tabContent[tab='" + tabName + "']").outerHeight() < 170)
				{
					$(".tabContent[tab='" + tabName + "']").animate({minHeight: "170px"}, 300);
				}	
			});
			// remember what content is active
			$(".tabContent").removeClass("active");
			$(".tabContent[tab='" + tabName + "']").addClass("active");
			// update hash of URL
			if(window.location.hash != window.top.location.hash){
				tophash = window.top.location.hash;
				tophash = tophash.replace("#", "");
				if (tophash.indexOf("#") != -1){
					firsthash = tophash.substring(0, tophash.indexOf("#"));
				}
				else {
					firsthash = tophash;
				}
				window.top.location.hash = "#" + firsthash + "#" + tabName;
			}
			else{
			window.location.hash = tabName;
			}
			
		});
				
		function adjustToScreenWidth(){
		
			tabCount = $(".tabHeader").length;
			thisTab = 0;
			while(tabCount > thisTab)
			{
				if($(".tabHeader:eq(" + thisTab + ")").parent(".tabHeaderRow")){
					$(".tabHeader:eq(" + thisTab + ")").unwrap();
				}
				thisTab++;
			}
			
			// count rows
			var tabOffsets = new Array();
			for (var i = 0; i < $(".tabHeader").length; i++){
				tabOffset = $(".tabHeader:eq("+i+")").offset().top;
				$(".tabHeader:eq("+i+")").attr("offset",tabOffset);
				if(tabOffsets.indexOf(tabOffset) == -1){
					tabOffsets.push(tabOffset);
				}
			}			
			totalTabs = tabOffsets.length;
			// group tab headers into rows
			row = 0;
			while(row < tabOffsets.length)
			{
				if($(".tabHeader[offset='" + tabOffsets[row] + "']").parent(".tabHeaderRow")){
					$(".tabHeader[offset='" + tabOffsets[row] + "']").unwrap();
				}
				$(".tabHeader[offset='" + tabOffsets[row] + "']").wrapAll("<div class='tabHeaderRow' row='" + (row+1) + "' />");
				row++;
			}			
			thisTab = 0;
			$(".tabHeader").removeClass("activeLastRow");
			$(".tabHeader[row='" + row + "'].active").addClass("activeLastRow");
			
			// move tabs between rows to get even number
			attemptsToMake = totalTabs*2;
			attempt = 1;
			while (attempt < attemptsToMake){
				row = 1;
				while(row < totalTabs)
				{
					tabLengths = getTabLengths();
					while (tabLengths[0] > tabLengths[1]){
						
						tabToMove = $(".tabHeaderRow[row='" + row + "'] .tabHeader").last();
						rowToMoveTo = $(".tabHeaderRow[row='" + (row + 1) + "']");
						
						$(tabToMove).prependTo($(rowToMoveTo));
						
						tabLengths = getTabLengths();
					}
					row++;
				}
			attempt++;
			}
			
			if ($(".tabHeaderRow").first().width() < 300)
			{
				$(".tabHeader").addClass("small");
				
				thisTab = 0;
				while(thisTab < $(".tabHeader").length)
				{
					if($(".tabHeader:eq(" + thisTab + ")").parent(".tabHeaderRow")){
						$(".tabHeader:eq(" + thisTab + ")").unwrap();
					}
					thisTab++;
				}
			}
			else
			{
				$(".tabHeader").removeClass("small");
			}
			
			
			while(thisTab < $(".tabHeader").length)
			{
				if($(".tabHeader:eq(" + thisTab + ")").parent(".tabHeaderRow")){
					$(".tabHeader:eq(" + thisTab + ")").attr("row",$(".tabHeader:eq(" + thisTab + ")").parent(".tabHeaderRow").attr("row"));
				}
				thisTab++;
			}
		}
		
		adjustToScreenWidth();
		$(window).resize(function(){	
			adjustToScreenWidth();
		});
		
		function getTabLengths(){
			lengthOfThisRow = 0;
			$(".tabHeaderRow[row='" + row + "'] .tabHeader").each(function() {
				lengthOfThisRow += $(this).outerWidth(true);
			});
			lengthOfNextRow = 0;
			$(".tabHeaderRow[row='" + (row + 1) + "'] .tabHeader").each(function() {
				lengthOfNextRow += $(this).outerWidth(true);
			}); 
			
			tabLengths = new Array();
			tabLengths[0] = lengthOfThisRow;
			tabLengths[1] = lengthOfNextRow;
			return tabLengths;

		}
				
		function getLongestTab(){
			var longestTab = 0;
			$(".tabHeader").each(function(){
			   if($(this).width() > longestTab){
				 longestTab = $(this).width();
			   }
			});
			return longestTab;
		}
	}
	
	function openDefaultOrFirstTab(){
		if($(".tabHeader.defaultTab").length == 1)
		{
			$(".tabHeader.defaultTab").first().click();
		}
		else
		{
			$(".tabHeader").first().click();
		}
	}
	
	// get tab from URL parameters and open it
	tabToSelect = location.hash.replace("#", "").toLowerCase();
	if (tabToSelect != "")
	{
		if($(".tabHeader[tab='" + tabToSelect + "']").length > 0)
		{
			$(".tabHeader[tab='" + tabToSelect + "']").click();
		}
		else
		{
			openDefaultOrFirstTab();
		}
	}
	else
	{
			openDefaultOrFirstTab();
	}
	
	// Add margin before top row of tabs
	$(".tabHeaderRow").first().css("marginTop","2em");
	
	// Highlight header correctly
	row = $(".tabHeaderRow").length;
	$(".tabHeader.active[row='" + row + "']").addClass("activeLastRow");
	
	// Visual fix for IE
	if ( $.browser.msie ) {
		$(".tabHeader").css("marginRight","-4px");
	}
}